<template>
  <div>
    <modal
      id="add-food-modal"
      class="add-food-modal"
      size="800px"
      :show.sync="show"
      :footer="false"
    >
      <div class="add-food-wrapper">
        <div class="add-food-tabs">
          <header class="bg-gradient-primary">
            <input
              :value="search"
              type="search"
              class="form-control mb-2 font-8"
              placeholder="دنبال چه خوراکی میگردی؟"
              @input="search = $event.target.value"
            />
            <ul class="tabs list-unstyled">
              <li
                v-for="(tabName, tab) in tabs"
                :key="tab"
                :class="{ active: activeTab === tab }"
                @click="activeTab = tab"
              >
                <span>{{ tabName }}</span>
              </li>
            </ul>
          </header>
          <loader
            v-if="activeTab === 'food'"
            :loading="foodsLoading"
            class="tabs-content"
          >
            <div class="content">
              <ul>
                <li
                  v-for="food in filteredFoods"
                  :key="food.id"
                  :class="{
                    active: selectedFood && selectedFood.id === food.id
                  }"
                  @click="selectedFood = food"
                >
                  {{ food.title }}
                </li>
              </ul>
            </div>
          </loader>
          <loader
            v-if="activeTab === 'favorite'"
            :loading="favoriteFoodsLoading"
            class="tabs-content"
          >
            <div class="content">
              <ul>
                <li
                  v-for="food in filteredFavoriteFoods"
                  :key="food.id"
                  :class="{
                    active: selectedFood && selectedFood.id === food.id
                  }"
                  @click="selectedFood = food"
                >
                  {{ food.title }}
                </li>
              </ul>
            </div>
          </loader>
          <loader v-if="activeTab === 'tablecloth'" class="tabs-content">
            <div class="content"></div>
          </loader>
        </div>
        <div class="add-food-result" :class="{ active: selectedFood }">
          <transition name="zoom-out-in" mode="out-in">
            <div
              v-if="selectedFood"
              :key="selectedFood.id"
              class="select-food-details text-center pt-5 pb-3"
            >
              <div>
                <div
                  class="image-circle has-border"
                  :style="{ backgroundImage: `url(${selectedFood.img})` }"
                />
                <p class="text-primary">
                  <span>{{ selectedFood.title }}</span>
                  <template v-if="selectedFood.nature !== 0">
                    <span>
                      (طبع: {{ $enums.foodNature[selectedFood.nature] }})
                    </span>
                  </template>
                </p>
              </div>

              <div>
                <p class="mt-1 mb-1 text-bold">انتخاب واحد اندازه گیری</p>
                <horizontal-select
                  v-model="form.unitId"
                  :options="units"
                  class="unit-select"
                />
                <p class="mt-3 mb-1 text-bold">انتخاب میزان مصرف</p>
                <input-number v-model="form.unitValue" :min="1" />
              </div>

              <div class="button-group">
                <button
                  type="button"
                  class="btn btn-circle btn-default ml-3 btn-cancel"
                  @click="selectedFood = null"
                >
                  <v-icon name="arrow-right" width="24" />
                </button>
                <button
                  type="button"
                  class="btn btn-success font-9 btn-submit"
                  @click="submit"
                >
                  <span>تایید</span>
                  <span>({{ calorie }} کالری)</span>
                </button>
              </div>
            </div>
            <p v-else class="empty-text mb-0">لطفا یک غذا انتخاب کنید</p>
          </transition>
        </div>
      </div>
      <v-icon name="x" class="close-modal" @click.native="show = false" />
    </modal>
  </div>
</template>

<script>
import HorizontalSelect from '../helper/HorizontalSelect'
import InputNumber from '../helper/inputNumber/InputNumber'
export default {
  name: 'AddFoodModal',
  components: { HorizontalSelect, InputNumber },
  props: {
    active: { type: [Boolean, Number], default: false }
  },
  data() {
    return {
      // loading keys
      foodsLoading: false,
      favoriteFoodsLoading: false,

      //searched text
      search: '',

      // active tab
      activeTab: 'food',

      selectedFood: null,

      form: {
        foodId: '',
        unitId: 0,
        unitValue: 0
      },
      tabs: {
        food: 'خوراکی',
        favorite: 'مورد علاقه'
        // tablecloth: 'سفره'
      }
    }
  },
  computed: {
    show: {
      set(val) {
        if (!val) this.selectedFood = null
        this.$emit('update:active', !!val)
      },
      get() {
        return !!this.active
      }
    },
    units() {
      if (!this.selectedFood) return []
      return this.selectedFood.units.slice()
    },
    calorie() {
      let food = this.selectedFood
      if (!food) return 0

      let unit = this.units.find(u => u.id === this.form.unitId)
      if (!unit) return 0

      // how much gram is this unit ?
      // grams = unit.value
      // caloriePerGram = food.calorie
      return Math.round(unit.value * food.calorie * this.form.unitValue)
    },
    filteredFoods() {
      let foods = this.$store.state.food.foods
      if (this.search === '') return foods
      return foods.filter(f => f.search.includes(this.search))
    },
    filteredFavoriteFoods() {
      let foods = this.$store.getters['food/favoriteFoods']
      if (this.search === '') return foods
      return foods.filter(f => f.search.includes(this.search))
    }
  },
  watch: {
    selectedFood: {
      handler(food) {
        if (food && food.id) {
          // find a unit which is not gram
          let unit = food.units.find(u => u.id !== this.$config.gramUnitId)
          this.form.unitId = unit
            ? unit.id
            : food.units.length
            ? food.units[0].id
            : 0
        }

        let query = this.$route.query
        if (food && food.id) {
          this.$router[query.selected ? 'replace' : 'push']({
            query: {
              ...query,
              selected: food.id
            }
          })
        } else if (query.selected) {
          this.$router.back()
        }
      },
      deep: true
    },
    'form.unitId'(unitId) {
      this.form.unitValue = this.$config.unitsPreValue[unitId] || 1
    },
    active(val) {
      if (val) this.getFoods()
      // unset selected food in phone
      // due to showing foods list
      if (window.innerWidth < 768) {
        this.selectedFood = null
      }
    },
    activeTab(tab) {
      if (tab === 'favorite') this.getFavoriteFoods()
      // empty the search input
      this.search = ''
    },
    $route: {
      handler(after) {
        let q = after.query
        let food = this.selectedFood
        if (q.selected) {
          let qid = q.selected * 1
          if (food && food.id === qid) return
          food = this.$store.state.food.foods.find(f => f.id === qid)
          if (food) this.selectedFood = food
        } else {
          this.selectedFood = null
        }
      },
      immediate: true,
      deep: true
    }
  },
  methods: {
    getFoods() {
      if (this.$store.state.food.foods.length) return
      this.$store.dispatch('food/getAllFoods', {
        $vm: this,
        $loadingKey: 'foodsLoading'
      })
    },
    getFavoriteFoods() {
      if (this.$store.state.food.favoriteFoods.length) return
      this.$store.dispatch('food/getFavoriteFoods', {
        $vm: this,
        $loadingKey: 'favoriteFoodsLoading'
      })
    },
    submit() {
      let msg = null
      if (!this.selectedFood) msg = 'هیچ غذایی انتخاب نشده!'
      if (!this.form.unitId) msg = 'واحد انتخاب نشده!'
      if (!this.form.unitValue) msg = 'مقدار واحد انتخاب نشده'
      if (msg) return this.$message.error(msg)
      let unit = this.units.find(u => u.id === this.form.unitId) || {}
      this.$emit('submit', {
        foodId: this.selectedFood.id,
        unitId: unit.id,
        unitValue: this.form.unitValue,
        unitTitle: unit.title,
        calorie: this.calorie
      })
      this.selectedFood = null
    }
  }
}
</script>
